## zimpl 2.05.ds2

=== Makefile ===
# $Id: Makefile,v 1.48 2006/09/18 09:22:13 bzfkocht Exp $
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*   File....: Makefile                                                      *
#*   Name....: Zimpl Makefile                                                *
#*   Author..: Thorsten Koch                                                 *
#*   Copyright by Author, All rights reserved                                *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*
#* Copyright (C) 2006 by Thorsten Koch <koch@zib.de>
#* 
#* This program is free software; you can redistribute it and/or
#* modify it under the terms of the GNU General Public License
#* as published by the Free Software Foundation; either version 2
#* of the License, or (at your option) any later version.
#* 
#* This program is distributed in the hope that it will be useful,
#* but WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU General Public License for more details.
#* 
#* You should have received a copy of the GNU General Public License
#* along with this program; if not, write to the Free Software
#* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#*
#
.PHONY:		depend clean lint doc check valgrind libdbl

ARCH            :=      $(shell uname -m | \
                        sed \
			-e s/sun../sparc/ \
			-e s/i.86/x86/ \
			-e s/i86pc/x86/ \
			-e s/IP../mips/ \
			-e s/9000..../hppa/ \
			-e s/Power\ Macintosh/ppc/ \
			-e s/00........../pwr4/)
OSTYPE          :=      $(shell uname -s | \
                        tr '[:upper:]' '[:lower:]' | \
                        sed \
			-e s/cygwin.*/cygwin/ \
                        -e s/irix../irix/ )
HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')

VERSION		=	2.05
OPT		=	opt
COMP		=	gnu
CC		=	gcc
YACC		=	bison
LEX		=	flex
DCC		=	gcc
LINT		=	flexelint
AR		=	ar
RANLIB		=	ranlib
VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
			--leak-resolution=high --show-reachable=yes 

SRCDIR		=	src
BINDIR		=	bin
LIBDIR		=	lib

CPPFLAGS	=	-I$(SRCDIR) -DVERSION='"$(VERSION)"'
CFLAGS		=	-O
LDFLAGS		=	-lgmp -lz -lm
YFLAGS		=	-d -t -v  
LFLAGS		=	-d
ARFLAGS		=	cr
DFLAGS		=	-MM

GCCWARN		=	-Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
			-Wstrict-prototypes -Wmissing-prototypes -Winline \
			-Wmissing-declarations -Wshadow -Waggregate-return \
			-Wno-unused -Wno-unknown-pragmas 

BASE		=	$(OSTYPE).$(ARCH).$(COMP).$(OPT)
OBJDIR		=	obj/O.$(BASE)
NAME		=	zimpl
TARGET		=	$(NAME)-$(VERSION).$(BASE)
LIBRARY		=	$(LIBDIR)/lib$(TARGET).a
LIBRARYDBL	=	$(LIBDIR)/lib$(TARGET).dbl.a
BINARY		=	$(BINDIR)/$(TARGET)
DEPEND		=	$(SRCDIR)/depend

#-----------------------------------------------------------------------------

OBJECT  	=       zimpl.o xlpglue.o \
			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
			ratordwrite.o ratpresolve.o ratsoswrite.o rathumwrite.o 
LIBBASE		=	bound.o code.o conname.o define.o elem.o entry.o \
			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
			load.o local.o metaio.o mmlparse.o mmlscan.o numbgmp.o \
			prog.o rdefpar.o source.o \
			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
			setmulti.o set4.o stmt.o strstore.o symbol.o term.o \
			tuple.o vinst.o mshell.o zimpllib.o
LIBOBJ		=	$(LIBBASE) gmpmisc.o numbgmp.o
LIBDBLOBJ	=	$(LIBBASE) numbdbl.o
OBJXXX		=	$(addprefix $(OBJDIR)/,$(OBJECT))
LIBXXX		=	$(addprefix $(OBJDIR)/,$(LIBOBJ))
LIBDBLXXX	=	$(addprefix $(OBJDIR)/,$(LIBDBLOBJ))
OBJSRC		=	$(addprefix $(SRCDIR)/,$(OBJECT:.o=.c))
LIBSRC		=	$(addprefix $(SRCDIR)/,$(LIBOBJ:.o=.c)) #(SRCDIR)/numbdbl.c

#-----------------------------------------------------------------------------
include make/make.$(BASE)
-include make/local/make.$(HOSTNAME)
-include make/local/make.$(HOSTNAME).$(COMP)
-include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
#-----------------------------------------------------------------------------

$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(TARGET) $(LDFLAGS) -o $@

$(LIBRARY):	$(LIBDIR) $(LIBXXX) 
		-rm -f $(LIBRARY)
		$(AR) $(ARFLAGS) $@ $(LIBXXX)
		$(RANLIB) $@

libdbl:		$(LIBRARYDBL)

$(LIBRARYDBL):	$(LIBDIR) $(LIBDBLXXX) 
		-rm -f $(LIBRARYDBL)
		$(AR) $(ARFLAGS) $@ $(LIBDBLXXX)
		$(RANLIB) $@

$(SRCDIR)/mmlparse.c:	$(SRCDIR)/mmlparse.y $(SRCDIR)/mme.h
		$(YACC) $(YFLAGS) -o $@ $<

$(SRCDIR)/mmlscan.c:	$(SRCDIR)/mmlscan.l $(SRCDIR)/mme.h
		$(LEX) $(LFLAGS) -o$@ $< 

lint:		$(OBJSRC) $(LIBSRC)
		$(LINT) $(SRCDIR)/project.lnt -os\(lint.out\) \
		$(CPPFLAGS) -UNDEBUG -Dinline= -DNO_MSHELL $^

doc:
		cd doc; make -f Makefile

check:
		cd check; \
		/bin/sh ./check.sh ../$(BINARY) 

valgrind:
		cd check; \
		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)" 

$(OBJDIR):	
		-mkdir -p $(OBJDIR)

$(LIBDIR):
		-mkdir -p $(LIBDIR)

$(BINDIR):
		-mkdir -p $(BINDIR)

clean:
		-rm -rf $(OBJDIR)/* $(TARGET)

depend:
		$(SHELL) -ec '$(DCC) $(DFLAGS) $(CPPFLAGS) $(OBJSRC) $(LIBSRC) \
		| sed '\''s|^\([0-9A-Za-z\_]\{1,\}\)\.o|$$\(OBJDIR\)/\1.o|g'\'' \
		>$(DEPEND)'

-include	$(DEPEND)

$(OBJDIR)/%.o:	$(SRCDIR)/%.c
		$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

# --- EOF ---------------------------------------------------------------------

## zimpl 2.07.ds1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.48 2006/09/18 09:22:13 bzfkocht Exp $
+# $Id: Makefile,v 1.64 2007/08/27 19:26:06 bzfpfets Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -8,7 +8,7 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2006 by Thorsten Koch <koch@zib.de>
+#* Copyright (C) 2005-2007 by Thorsten Koch <koch@zib.de>
 #* 
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
@@ -25,7 +25,7 @@
 #* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 #*
 #
-.PHONY:		depend clean lint doc check valgrind libdbl
+.PHONY:		all depend clean lint doc check valgrind libdbl coverage
 
 ARCH            :=      $(shell uname -m | \
                         sed \
@@ -43,7 +43,9 @@
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	2.05
+VERSION		=	2.07
+
+VERBOSE		=	false
 OPT		=	opt
 COMP		=	gnu
 CC		=	gcc
@@ -76,23 +78,35 @@
 BASE		=	$(OSTYPE).$(ARCH).$(COMP).$(OPT)
 OBJDIR		=	obj/O.$(BASE)
 NAME		=	zimpl
-TARGET		=	$(NAME)-$(VERSION).$(BASE)
-LIBRARY		=	$(LIBDIR)/lib$(TARGET).a
-LIBRARYDBL	=	$(LIBDIR)/lib$(TARGET).dbl.a
-BINARY		=	$(BINDIR)/$(TARGET)
+BINNAME		=	$(NAME)-$(VERSION).$(BASE)
+LIBNAME		=	$(NAME)-$(VERSION).$(BASE)
+LIBFILENAME	=	lib$(LIBNAME).a
+LIBDBLFILENAME	=	lib$(LIBNAME).dbl.a
+LIBRARY		=	$(LIBDIR)/$(LIBFILENAME)
+LIBRARYDBL	=	$(LIBDIR)/$(LIBDBLFILENAME)
+BINARY		=	$(BINDIR)/$(BINNAME)
+LIBLINKNAME	=	lib$(NAME).$(BASE).a
+LIBLINK		=	$(LIBDIR)/$(LIBLINKNAME)
+LIBDBLLINKNAME	=	lib$(NAME).$(BASE).dbl.a
+LIBDBLLINK	=	$(LIBDIR)/$(LIBDBLLINKNAME)
+BINLINKNAME	=	$(NAME).$(BASE)
+BINLINK		=	$(BINDIR)/$(BINLINKNAME)
+BINSHORTLINKNAME=	$(NAME)
+BINSHORTLINK	=	$(BINDIR)/$(BINSHORTLINKNAME)
 DEPEND		=	$(SRCDIR)/depend
 
 #-----------------------------------------------------------------------------
 
 OBJECT  	=       zimpl.o xlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
-			ratordwrite.o ratpresolve.o ratsoswrite.o rathumwrite.o 
-LIBBASE		=	bound.o code.o conname.o define.o elem.o entry.o \
+			ratrlpwrite.o ratordwrite.o ratpresolve.o ratsoswrite.o \
+			rathumwrite.o 
+LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
 			load.o local.o metaio.o mmlparse.o mmlscan.o numbgmp.o \
-			prog.o rdefpar.o source.o \
+			prog.o random.o rdefpar.o source.o \
 			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
-			setmulti.o set4.o stmt.o strstore.o symbol.o term.o \
+			setmulti.o set4.o stmt.o strstore2.o symbol.o term.o \
 			tuple.o vinst.o mshell.o zimpllib.o
 LIBOBJ		=	$(LIBBASE) gmpmisc.o numbgmp.o
 LIBDBLOBJ	=	$(LIBBASE) numbdbl.o
@@ -109,25 +123,52 @@
 -include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
 #-----------------------------------------------------------------------------
 
+ifeq ($(VERBOSE),false)
+.SILENT:	$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK) $(SRCDIR)/mmlparse.c $(SRCDIR)/mmlscan.c $(OBJXXX) $(LIBXXX) $(LIBDBLXXX)
+endif
+
+all:		$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK)
+
+$(LIBLINK):	$(LIBRARY)
+		@rm -f $@
+		cd $(LIBDIR) && ln -s $(LIBFILENAME) $(LIBLINKNAME)
+
+$(LIBDBLLINK):	$(LIBRARYDBL)
+		@rm -f $@
+		cd $(LIBDIR) && ln -s $(LIBDBLFILENAME) $(LIBDBLLINKNAME)
+
+$(BINLINK):	$(BINARY)
+		@rm -f $@
+		cd $(BINDIR) && ln -s $(BINNAME) $(BINLINKNAME)
+
+$(BINSHORTLINK):	$(BINARY)
+		@rm -f $@
+		cd $(BINDIR) && ln -s $(BINNAME) $(BINSHORTLINKNAME)
+
 $(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
-		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(TARGET) $(LDFLAGS) -o $@
-
-$(LIBRARY):	$(LIBDIR) $(LIBXXX) 
+		@echo "-> linking $@"
+		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) -o $@
+
+$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
+		@echo "-> generating library $@"
 		-rm -f $(LIBRARY)
 		$(AR) $(ARFLAGS) $@ $(LIBXXX)
 		$(RANLIB) $@
 
-libdbl:		$(LIBRARYDBL)
-
-$(LIBRARYDBL):	$(LIBDIR) $(LIBDBLXXX) 
+libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)
+
+$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX) 
+		@echo "-> generating library $@"
 		-rm -f $(LIBRARYDBL)
 		$(AR) $(ARFLAGS) $@ $(LIBDBLXXX)
 		$(RANLIB) $@
 
 $(SRCDIR)/mmlparse.c:	$(SRCDIR)/mmlparse.y $(SRCDIR)/mme.h
+		@echo "-> generating yacc parser $@"
 		$(YACC) $(YFLAGS) -o $@ $<
 
 $(SRCDIR)/mmlscan.c:	$(SRCDIR)/mmlscan.l $(SRCDIR)/mme.h
+		@echo "-> generating lex scanner $@"
 		$(LEX) $(LFLAGS) -o$@ $< 
 
 lint:		$(OBJSRC) $(LIBSRC)
@@ -145,17 +186,30 @@
 		cd check; \
 		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)" 
 
+coverage:
+		-ln -s ../../src $(OBJDIR)
+		-mkdir -p gcov
+		lcov -d $(OBJDIR) -z
+		make OPT=gcov check
+		lcov -d $(OBJDIR) -c >gcov/z.capture
+		lcov -d $(OBJDIR) -r gcov/z.capture "*mmlscan.c" "*mmlparse.c" >gcov/zimpl.capture
+		genhtml -o gcov gcov/zimpl.capture
+		-rm gcov/z.capture
+
 $(OBJDIR):	
-		-mkdir -p $(OBJDIR)
+		@echo "** creating directory \"$@\""
+		@-mkdir -p $(OBJDIR)
 
 $(LIBDIR):
-		-mkdir -p $(LIBDIR)
+		@echo "** creating directory \"$@\""
+		@-mkdir -p $(LIBDIR)
 
 $(BINDIR):
-		-mkdir -p $(BINDIR)
+		@echo "** creating directory \"$@\""
+		@-mkdir -p $(BINDIR)
 
 clean:
-		-rm -rf $(OBJDIR)/* $(TARGET)
+		-rm -rf $(OBJDIR)/* $(BINARY) $(LIBRARY) $(LIBRARYDBL)
 
 depend:
 		$(SHELL) -ec '$(DCC) $(DFLAGS) $(CPPFLAGS) $(OBJSRC) $(LIBSRC) \
@@ -165,11 +219,7 @@
 -include	$(DEPEND)
 
 $(OBJDIR)/%.o:	$(SRCDIR)/%.c
+		@echo "-> compiling $@"
 		$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@
 
 # --- EOF ---------------------------------------------------------------------
-
-
-
-
-

## zimpl 2.09.ds1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.64 2007/08/27 19:26:06 bzfpfets Exp $
+# $Id$
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -8,7 +8,7 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2007 by Thorsten Koch <koch@zib.de>
+#* Copyright (C) 2005-2008 by Thorsten Koch <koch@zib.de>
 #* 
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
@@ -43,8 +43,7 @@
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	2.07
-
+VERSION		=	2.09
 VERBOSE		=	false
 OPT		=	opt
 COMP		=	gnu
@@ -80,31 +79,24 @@
 NAME		=	zimpl
 BINNAME		=	$(NAME)-$(VERSION).$(BASE)
 LIBNAME		=	$(NAME)-$(VERSION).$(BASE)
-LIBFILENAME	=	lib$(LIBNAME).a
-LIBDBLFILENAME	=	lib$(LIBNAME).dbl.a
-LIBRARY		=	$(LIBDIR)/$(LIBFILENAME)
-LIBRARYDBL	=	$(LIBDIR)/$(LIBDBLFILENAME)
+LIBRARY		=	$(LIBDIR)/lib$(LIBNAME).a
+LIBRARYDBL	=	$(LIBDIR)/lib$(LIBNAME).dbl.a
 BINARY		=	$(BINDIR)/$(BINNAME)
-LIBLINKNAME	=	lib$(NAME).$(BASE).a
-LIBLINK		=	$(LIBDIR)/$(LIBLINKNAME)
-LIBDBLLINKNAME	=	lib$(NAME).$(BASE).dbl.a
-LIBDBLLINK	=	$(LIBDIR)/$(LIBDBLLINKNAME)
-BINLINKNAME	=	$(NAME).$(BASE)
-BINLINK		=	$(BINDIR)/$(BINLINKNAME)
-BINSHORTLINKNAME=	$(NAME)
-BINSHORTLINK	=	$(BINDIR)/$(BINSHORTLINKNAME)
+LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE).a
+LIBDBLLINK	=	$(LIBDIR)/lib$(NAME).$(BASE).dbl.a
+BINLINK		=	$(BINDIR)/$(NAME).$(BASE)
+BINSHORTLINK	=	$(BINDIR)/$(NAME)
 DEPEND		=	$(SRCDIR)/depend
 
 #-----------------------------------------------------------------------------
 
 OBJECT  	=       zimpl.o xlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
-			ratrlpwrite.o ratordwrite.o ratpresolve.o ratsoswrite.o \
-			rathumwrite.o 
+			ratrlpwrite.o ratordwrite.o ratpresolve.o rathumwrite.o 
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
-			load.o local.o metaio.o mmlparse.o mmlscan.o numbgmp.o \
-			prog.o random.o rdefpar.o source.o \
+			load.o local.o metaio.o mmlparse.o mmlscan.o \
+			numbgmp.o prog.o random.o rdefpar.o source.o \
 			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
 			setmulti.o set4.o stmt.o strstore2.o symbol.o term.o \
 			tuple.o vinst.o mshell.o zimpllib.o
@@ -124,26 +116,23 @@
 #-----------------------------------------------------------------------------
 
 ifeq ($(VERBOSE),false)
-.SILENT:	$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK) $(SRCDIR)/mmlparse.c $(SRCDIR)/mmlscan.c $(OBJXXX) $(LIBXXX) $(LIBDBLXXX)
+.SILENT:	$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK) \
+		$(SRCDIR)/mmlparse2.c $(SRCDIR)/mmlscan.c $(OBJXXX) $(LIBXXX) $(LIBDBLXXX)
 endif
 
 all:		$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK)
 
 $(LIBLINK):	$(LIBRARY)
 		@rm -f $@
-		cd $(LIBDIR) && ln -s $(LIBFILENAME) $(LIBLINKNAME)
+		cd $(dir $@) && ln -s $(notdir $(LIBRARY)) $(notdir $@)
 
 $(LIBDBLLINK):	$(LIBRARYDBL)
 		@rm -f $@
-		cd $(LIBDIR) && ln -s $(LIBDBLFILENAME) $(LIBDBLLINKNAME)
-
-$(BINLINK):	$(BINARY)
+		cd $(dir $@) && ln -s $(notdir $(LIBRARYDBL)) $(notdir $@)
+
+$(BINLINK) $(BINSHORTLINK):	$(BINARY)
 		@rm -f $@
-		cd $(BINDIR) && ln -s $(BINNAME) $(BINLINKNAME)
-
-$(BINSHORTLINK):	$(BINARY)
-		@rm -f $@
-		cd $(BINDIR) && ln -s $(BINNAME) $(BINSHORTLINKNAME)
+		cd $(dir $@) && ln -s $(notdir $(BINARY)) $(notdir $@)
 
 $(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
 		@echo "-> linking $@"
@@ -192,7 +181,7 @@
 		lcov -d $(OBJDIR) -z
 		make OPT=gcov check
 		lcov -d $(OBJDIR) -c >gcov/z.capture
-		lcov -d $(OBJDIR) -r gcov/z.capture "*mmlscan.c" "*mmlparse.c" >gcov/zimpl.capture
+		lcov -d $(OBJDIR) -r gcov/z.capture "*mmlscan.c" "*mmlparse2.c" >gcov/zimpl.capture
 		genhtml -o gcov gcov/zimpl.capture
 		-rm gcov/z.capture
 
@@ -209,7 +198,7 @@
 		@-mkdir -p $(BINDIR)
 
 clean:
-		-rm -rf $(OBJDIR)/* $(BINARY) $(LIBRARY) $(LIBRARYDBL)
+		-rm -rf $(OBJDIR)/* $(BINARY) $(LIBRARY) $(LIBRARYDBL) $(LIBLINK) $(BINLINK) $(BINSHORTLINK)
 
 depend:
 		$(SHELL) -ec '$(DCC) $(DFLAGS) $(CPPFLAGS) $(OBJSRC) $(LIBSRC) \

## zimpl 3.0.0+dfsg1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2008 by Thorsten Koch <koch@zib.de>
+#* Copyright (C) 2005-2009 by Thorsten Koch <koch@zib.de>
 #* 
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
@@ -43,7 +43,7 @@
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	2.09
+VERSION		=	3.0.0
 VERBOSE		=	false
 OPT		=	opt
 COMP		=	gnu
@@ -95,10 +95,10 @@
 			ratrlpwrite.o ratordwrite.o ratpresolve.o rathumwrite.o 
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
-			load.o local.o metaio.o mmlparse.o mmlscan.o \
+			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
 			numbgmp.o prog.o random.o rdefpar.o source.o \
 			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
-			setmulti.o set4.o stmt.o strstore2.o symbol.o term.o \
+			setmulti.o set4.o stmt.o strstore2.o symbol.o term2.o \
 			tuple.o vinst.o mshell.o zimpllib.o
 LIBOBJ		=	$(LIBBASE) gmpmisc.o numbgmp.o
 LIBDBLOBJ	=	$(LIBBASE) numbdbl.o
@@ -152,7 +152,7 @@
 		$(AR) $(ARFLAGS) $@ $(LIBDBLXXX)
 		$(RANLIB) $@
 
-$(SRCDIR)/mmlparse.c:	$(SRCDIR)/mmlparse.y $(SRCDIR)/mme.h
+$(SRCDIR)/mmlparse2.c:	$(SRCDIR)/mmlparse2.y $(SRCDIR)/mme.h
 		@echo "-> generating yacc parser $@"
 		$(YACC) $(YFLAGS) -o $@ $<
 
@@ -161,7 +161,7 @@
 		$(LEX) $(LFLAGS) -o$@ $< 
 
 lint:		$(OBJSRC) $(LIBSRC)
-		$(LINT) $(SRCDIR)/project.lnt -os\(lint.out\) \
+		$(LINT) $(SRCDIR)/project.lnt \
 		$(CPPFLAGS) -UNDEBUG -Dinline= -DNO_MSHELL $^
 
 doc:

## zimpl 3.1.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id$
+# $Id: Makefile,v 1.76 2010/09/30 14:45:12 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -8,7 +8,7 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2009 by Thorsten Koch <koch@zib.de>
+#* Copyright (C) 2005-2010 by Thorsten Koch <koch@zib.de>
 #* 
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
@@ -38,12 +38,13 @@
 			-e s/00........../pwr4/)
 OSTYPE          :=      $(shell uname -s | \
                         tr '[:upper:]' '[:lower:]' | \
+			tr -d '[:punct:]' | \
                         sed \
 			-e s/cygwin.*/cygwin/ \
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.0.0
+VERSION		=	3.1.0
 VERBOSE		=	false
 OPT		=	opt
 COMP		=	gnu
@@ -92,7 +93,7 @@
 
 OBJECT  	=       zimpl.o xlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
-			ratrlpwrite.o ratordwrite.o ratpresolve.o rathumwrite.o 
+			ratordwrite.o ratpresolve.o  
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
 			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
@@ -115,6 +116,14 @@
 -include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
 #-----------------------------------------------------------------------------
 
+FLAGS           +=      $(USRFLAGS)
+OFLAGS          +=      $(USROFLAGS)
+CFLAGS          +=      $(USRCFLAGS) $(USROFLAGS)
+LDFLAGS         +=      $(USRLDFLAGS)
+ARFLAGS         +=      $(USRARFLAGS)
+DFLAGS          +=      $(USRDFLAGS)
+
+
 ifeq ($(VERBOSE),false)
 .SILENT:	$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK) \
 		$(SRCDIR)/mmlparse2.c $(SRCDIR)/mmlscan.c $(OBJXXX) $(LIBXXX) $(LIBDBLXXX)

## zimpl 3.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.76 2010/09/30 14:45:12 bzfkocht Exp $
+# $Id: Makefile,v 1.82 2011/10/31 08:48:56 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -25,27 +25,31 @@
 #* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 #*
 #
-.PHONY:		all depend clean lint doc check valgrind libdbl coverage
+.PHONY:		all depend clean lint doc doxygen check valgrind libdbl coverage
 
 ARCH            :=      $(shell uname -m | \
                         sed \
 			-e s/sun../sparc/ \
 			-e s/i.86/x86/ \
 			-e s/i86pc/x86/ \
+			-e s/amd64/x86_64/ \
 			-e s/IP../mips/ \
 			-e s/9000..../hppa/ \
 			-e s/Power\ Macintosh/ppc/ \
 			-e s/00........../pwr4/)
 OSTYPE          :=      $(shell uname -s | \
                         tr '[:upper:]' '[:lower:]' | \
-			tr -d '[:punct:]' | \
+			tr '/' '_' | \
                         sed \
 			-e s/cygwin.*/cygwin/ \
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.1.0
+VERSION		=	3.2.0
 VERBOSE		=	false
+SHARED		=	false
+STATIC		=	false
+LINK		=	normal
 OPT		=	opt
 COMP		=	gnu
 CC		=	gcc
@@ -53,8 +57,9 @@
 LEX		=	flex
 DCC		=	gcc
 LINT		=	flexelint
-AR		=	ar
+AR		=	ar cr
 RANLIB		=	ranlib
+DOXY		=	doxygen
 VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
 			--leak-resolution=high --show-reachable=yes 
 
@@ -67,7 +72,7 @@
 LDFLAGS		=	-lgmp -lz -lm
 YFLAGS		=	-d -t -v  
 LFLAGS		=	-d
-ARFLAGS		=	cr
+ARFLAGS		=	
 DFLAGS		=	-MM
 
 GCCWARN		=	-Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
@@ -75,14 +80,22 @@
 			-Wmissing-declarations -Wshadow -Waggregate-return \
 			-Wno-unused -Wno-unknown-pragmas 
 
+ifeq ($(SHARED),true)
+LINK		=	shared
+endif
+ifeq ($(STATIC),true)
+LINK		=	static
+endif
+
 BASE		=	$(OSTYPE).$(ARCH).$(COMP).$(OPT)
-OBJDIR		=	obj/O.$(BASE)
+OBJDIR		=	obj/O.$(OSTYPE).$(ARCH).$(COMP).$(LINK).$(OPT)
 NAME		=	zimpl
-BINNAME		=	$(NAME)-$(VERSION).$(BASE)
+BINNAME		=	$(NAME)-$(VERSION).$(OSTYPE).$(ARCH).$(COMP).$(LINK).$(OPT)
 LIBNAME		=	$(NAME)-$(VERSION).$(BASE)
 LIBRARY		=	$(LIBDIR)/lib$(LIBNAME).a
 LIBRARYDBL	=	$(LIBDIR)/lib$(LIBNAME).dbl.a
 BINARY		=	$(BINDIR)/$(BINNAME)
+BINARYDBL	=	$(BINDIR)/$(BINNAME).dbl
 LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE).a
 LIBDBLLINK	=	$(LIBDIR)/lib$(NAME).$(BASE).dbl.a
 BINLINK		=	$(BINDIR)/$(NAME).$(BASE)
@@ -91,16 +104,16 @@
 
 #-----------------------------------------------------------------------------
 
-OBJECT  	=       zimpl.o xlpglue.o \
+OBJECT  	=       zimpl.o xlpglue.o zlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
 			ratordwrite.o ratpresolve.o  
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
-			gmpmisc.o hash.o heap.o idxset.o inst.o iread.o list.o \
+			hash.o heap.o idxset.o inst.o iread.o list.o \
 			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
-			numbgmp.o prog.o random.o rdefpar.o source.o \
+			mshell.o prog.o random.o rdefpar.o source.o \
 			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
-			setmulti.o set4.o stmt.o strstore2.o symbol.o term2.o \
-			tuple.o vinst.o mshell.o zimpllib.o
+			setmulti.o set4.o stmt.o stkchk.o strstore2.o symbol.o \
+			term2.o tuple.o vinst.o zimpllib.o
 LIBOBJ		=	$(LIBBASE) gmpmisc.o numbgmp.o
 LIBDBLOBJ	=	$(LIBBASE) numbdbl.o
 OBJXXX		=	$(addprefix $(OBJDIR)/,$(OBJECT))
@@ -110,7 +123,7 @@
 LIBSRC		=	$(addprefix $(SRCDIR)/,$(LIBOBJ:.o=.c)) #(SRCDIR)/numbdbl.c
 
 #-----------------------------------------------------------------------------
-include make/make.$(BASE)
+include make/make.$(OSTYPE).$(ARCH).$(COMP).$(OPT)
 -include make/local/make.$(HOSTNAME)
 -include make/local/make.$(HOSTNAME).$(COMP)
 -include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
@@ -147,10 +160,14 @@
 		@echo "-> linking $@"
 		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) -o $@
 
+$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL) 
+		@echo "-> linking $@"
+		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) -o $@
+
 $(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARY)
-		$(AR) $(ARFLAGS) $@ $(LIBXXX)
+		$(AR) $@ $(LIBXXX) $(ARFLAGS) 
 		$(RANLIB) $@
 
 libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)
@@ -158,7 +175,7 @@
 $(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX) 
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARYDBL)
-		$(AR) $(ARFLAGS) $@ $(LIBDBLXXX)
+		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS) 
 		$(RANLIB) $@
 
 $(SRCDIR)/mmlparse2.c:	$(SRCDIR)/mmlparse2.y $(SRCDIR)/mme.h
@@ -175,6 +192,9 @@
 
 doc:
 		cd doc; make -f Makefile
+
+doxygen:
+		cd doc; $(DOXY) $(NAME).dxy
 
 check:
 		cd check; \

=== debian/changelog ===
zimpl (3.2.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Changed packaging format to "3.0 (quilt)".
  * Update Standards-Version to 3.9.2 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Sun, 13 Nov 2011 13:12:01 +0100

zimpl (3.1.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Remove patch kfreebsd.dpatch: fixed upstream.
  * debian/control: Add missing "Depends: ${misc:Depends}".
  * Update Standards-Version to 3.9.1 (quote BSD license for some parts in
    debian/copyright).

 -- Joachim Reichel <reichel@debian.org>  Sat, 02 Oct 2010 20:45:30 +0200

zimpl (3.0.0+dfsg1-4) unstable; urgency=low

  * Make sure package does not get accidentally build as debug version
    (Closes: #552961).
  * Add patch display-check-failures.dpatch to simplify the debugging of
    failing unit tests.

 -- Joachim Reichel <reichel@debian.org>  Tue, 17 Nov 2009 20:12:43 +0100

zimpl (3.0.0+dfsg1-3) unstable; urgency=low

  * Add patch kfreebsd.dpatch: Fix build error on kFreeBSD (Closes: #550282).
  * Improve patch build.dpatch: Fail if not all tests pass.

 -- Joachim Reichel <reichel@debian.org>  Tue, 20 Oct 2009 18:59:04 +0200

zimpl (3.0.0+dfsg1-2) unstable; urgency=low

  * Re-enable test suite which was accidentially disabled in 2.09.ds1-1.

 -- Joachim Reichel <reichel@debian.org>  Wed, 16 Sep 2009 19:32:40 +0200

zimpl (3.0.0+dfsg1-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.8.3 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Wed, 16 Sep 2009 18:46:52 +0200

zimpl (2.09.ds1-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.8.1 (add support for nocheck in
    DEB_BUILD_OPTIONS).

 -- Joachim Reichel <reichel@debian.org>  Fri, 01 May 2009 17:08:30 +0200

zimpl (2.08.ds1-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Replace Suggests: glpk by new package name glpk-utils.
  * debian/control: Update Standards-Version to 3.8.0 (no changes needed).
  * Remove patch check.dpatch: No longer needed.

 -- Joachim Reichel <reichel@debian.org>  Sun, 18 Jan 2009 15:51:17 +0100

zimpl (2.07.ds1-2) unstable; urgency=low

  * debian/rules: Quote CFLAGS and CPPFLAGS in make calls (Closes: #476017),
    thanks to Mike O'Connor for the patch.
  * debian/control: Add Homepage: field, adjust Description: accordingly.
  * debian/control: Update Standards-Version to 3.7.3 (no changes needed).
  * Add patch manpage.dpatch: Fix typo in manpage.

 -- Joachim Reichel <joachim.reichel@gmx.de>  Wed, 16 Apr 2008 18:17:48 +0200

zimpl (2.07.ds1-1) unstable; urgency=low

  * New upstream release.
  * Add patch check.dpatch: the different number format is a known problem
    without consequences.
  * Add watch file.

 -- Joachim Reichel <joachim.reichel@gmx.de>  Mon,  3 Sep 2007 18:59:32 +0200

zimpl (2.05.ds2-1) unstable; urgency=low

  * New upstream release (upstream fixed some packaging errors without
    increasing the version number).
  * Update URL of homepage.

 -- Joachim Reichel <joachim.reichel@gmx.de>  Sat,  4 Nov 2006 16:50:36 +0100

zimpl (2.05.ds1-1) unstable; urgency=low

  * New upstream release.

 -- Joachim Reichel <joachim.reichel@gmx.de>  Mon, 18 Sep 2006 20:28:50 +0200

zimpl (2.04.ds1-1) unstable; urgency=low

  * Initial release (Closes: #365073).

 -- Joachim Reichel <joachim.reichel@gmx.de>  Wed, 19 Jul 2006 15:39:36 +0200

=== debian/control ===
Source: zimpl
Section: science
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends: debhelper (>= 8.0.0), libgmp3-dev, zlib1g-dev, quilt, bison, flex
Standards-Version: 3.9.2
Homepage: http://zimpl.zib.de/

Package: zimpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: glpk-utils
Description: mathematical modeling language for optimization problems
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

%:
	dh $@  --with quilt

override_dh_auto_build:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_build -- VERBOSE=true

override_dh_auto_test:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_test -- VERBOSE=true

override_dh_install:
	# replace symbolic link bin/zimpl by the link target
	cp -L bin/zimpl bin/zimpl.real
	rm bin/zimpl
	mv bin/zimpl.real bin/zimpl 
	dh_install bin/zimpl usr/bin

override_dh_installexamples:
	dh_installexamples example/*

override_dh_installman:
	dh_installman doc/zimpl.man

override_dh_auto_clean:
	dh_auto_clean
	cd check/warnings && rm -f w215.warn w215.tbl w215.mst w215.lp

get-orig-source:
	wget http://zimpl.zib.de/download/zimpl-3.2.0.tgz
	tar xzf zimpl-3.2.0.tgz
	rm zimpl-3.2.0.tgz
	rm -r zimpl-3.2.0/doc/zimpl.pdf
	mv zimpl-3.2.0 zimpl-3.2.0+dfsg
	tar cf - zimpl-3.2.0+dfsg | gzip --best >zimpl_3.2.0+dfsg.orig.tar.gz
	rm -r zimpl-3.2.0+dfsg

.PHONY: get-orig-source

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d+$//" http://zimpl.zib.de/download/zimpl-(.*)\.tgz

## zimpl 3.3.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.82 2011/10/31 08:48:56 bzfkocht Exp $
+# $Id: Makefile,v 1.83 2012/07/26 20:14:18 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -45,7 +45,7 @@
                         -e s/irix../irix/ )
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.2.0
+VERSION		=	3.3.0
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false

=== debian/changelog ===
zimpl (3.3.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Backup pre-generated flex and bison output files to restore them after
    the build process (which might trigger re-building them).

 -- Joachim Reichel <reichel@debian.org>  Thu, 02 Aug 2012 22:33:33 +0200

zimpl (3.2.0+dfsg-2) unstable; urgency=low

  * Change Build-Depends: libgmp3-dev to libgmp-dev.
  * Change Build-Depends: debhelper (>= 8.0.0) to debhelper (>= 9), update
    debian/compat to get the default build flags for hardening.
  * Add patch fix-format-security-error.patch to fix an error caused by
    -Wformat-security.
  * Remove Build-Depends: quilt.
  * Update Standards-Version to 3.9.3 (no changes needed).
  * Fix Format: line in debian/copyright.
  * Fix debian/watch.

 -- Joachim Reichel <reichel@debian.org>  Sun, 10 Jun 2012 14:52:17 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,12 @@
 # export DH_VERBOSE=1
 
 %:
-	dh $@  --with quilt
+	dh $@
 
 override_dh_auto_build:
+	for FILE in src/mmlparse2.c src/mmlparse2.h src/mmlscan.c; do cp -a $$FILE $$FILE.sik; done
 	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_build -- VERBOSE=true
+	for FILE in src/mmlparse2.c src/mmlparse2.h src/mmlscan.c; do mv $$FILE.sik $$FILE; done
 
 override_dh_auto_test:
 	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_test -- VERBOSE=true

## zimpl 3.3.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.83 2012/07/26 20:14:18 bzfkocht Exp $
+# $Id: Makefile,v 1.84 2012/11/23 13:03:38 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -42,10 +42,13 @@
 			tr '/' '_' | \
                         sed \
 			-e s/cygwin.*/cygwin/ \
-                        -e s/irix../irix/ )
+                        -e s/irix../irix/ \
+                        -e s/windows.*/windows/ \
+                        -e s/mingw.*/mingw/)
+
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.3.0
+VERSION		=	3.3.1
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false

=== debian/changelog ===
zimpl (3.3.1+dfsg-1) unstable; urgency=low

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Sun, 14 Apr 2013 19:37:34 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: science
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
-Build-Depends: debhelper (>= 8.0.0), libgmp3-dev, zlib1g-dev, quilt, bison, flex
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), libgmp-dev, zlib1g-dev, bison, flex
+Standards-Version: 3.9.3
 Homepage: http://zimpl.zib.de/
 
 Package: zimpl

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d*$//" http://zimpl.zib.de/download/zimpl-(.*)\.tgz

## zimpl 3.3.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.84 2012/11/23 13:03:38 bzfkocht Exp $
+# $Id: Makefile,v 1.86 2014/01/12 11:07:04 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -48,10 +48,11 @@
 
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.3.1
+VERSION		=	3.3.2
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false
+ZLIB		=	true
 LINK		=	normal
 OPT		=	opt
 COMP		=	gnu
@@ -72,7 +73,7 @@
 
 CPPFLAGS	=	-I$(SRCDIR) -DVERSION='"$(VERSION)"'
 CFLAGS		=	-O
-LDFLAGS		=	-lgmp -lz -lm
+LDFLAGS		=	-lgmp -lm
 YFLAGS		=	-d -t -v  
 LFLAGS		=	-d
 ARFLAGS		=	
@@ -82,6 +83,12 @@
 			-Wstrict-prototypes -Wmissing-prototypes -Winline \
 			-Wmissing-declarations -Wshadow -Waggregate-return \
 			-Wno-unused -Wno-unknown-pragmas 
+
+ifeq ($(ZLIB),true)
+LDFLAGS		+=	-lz
+else
+CPPFLAGS	+=	-DWITHOUT_ZLIB
+endif
 
 ifeq ($(SHARED),true)
 LINK		=	shared

=== debian/changelog ===
zimpl (3.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Use Files-Excluded: in debian/copyright, remove get-orig-source target,
    update debian/README.source.
  * Update Standards-Version to 3.9.5 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Sun, 18 May 2014 16:23:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
 Build-Depends: debhelper (>= 9), libgmp-dev, zlib1g-dev, bison, flex
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://zimpl.zib.de/
 
 Package: zimpl

=== debian/rules ===
--- 
+++ 
@@ -31,12 +31,12 @@
 	cd check/warnings && rm -f w215.warn w215.tbl w215.mst w215.lp
 
 get-orig-source:
-	wget http://zimpl.zib.de/download/zimpl-3.2.0.tgz
-	tar xzf zimpl-3.2.0.tgz
-	rm zimpl-3.2.0.tgz
-	rm -r zimpl-3.2.0/doc/zimpl.pdf
-	mv zimpl-3.2.0 zimpl-3.2.0+dfsg
-	tar cf - zimpl-3.2.0+dfsg | gzip --best >zimpl_3.2.0+dfsg.orig.tar.gz
-	rm -r zimpl-3.2.0+dfsg
+	wget http://zimpl.zib.de/download/zimpl-3.3.1.tgz
+	tar xzf zimpl-3.3.1.tgz
+	rm zimpl-3.3.1.tgz
+	rm -r zimpl-3.3.1/doc/zimpl.pdf
+	mv zimpl-3.3.1 zimpl-3.3.1+dfsg
+	tar cf - zimpl-3.3.1+dfsg | gzip --best >zimpl_3.3.1+dfsg.orig.tar.gz
+	rm -r zimpl-3.3.1+dfsg
 
 .PHONY: get-orig-source

## zimpl 3.3.4

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,3 @@
-# $Id: Makefile,v 1.86 2014/01/12 11:07:04 bzfkocht Exp $
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*                                                                           *
 #*   File....: Makefile                                                      *
@@ -8,7 +7,7 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2010 by Thorsten Koch <koch@zib.de>
+#* Copyright (C) 2005-2017 by Thorsten Koch <koch@zib.de>
 #* 
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
@@ -48,20 +47,26 @@
 
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.3.2
+VERSION		=	3.3.4
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false
 ZLIB		=	true
-LINK		=	normal
+LINK		=	static
 OPT		=	opt
 COMP		=	gnu
-CC		=	gcc
+CC		   =	gcc
+CC_o	   = -o
+LINKCC   =	gcc
+LINKCC_o =	 -o #the white space is important
+LIBEXT	= .a
 YACC		=	bison
 LEX		=	flex
 DCC		=	gcc
 LINT		=	flexelint
-AR		=	ar cr
+CPPCHECK	=	cppcheck
+AR		   =	ar cr
+AR_o	   =
 RANLIB		=	ranlib
 DOXY		=	doxygen
 VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
@@ -102,12 +107,14 @@
 NAME		=	zimpl
 BINNAME		=	$(NAME)-$(VERSION).$(OSTYPE).$(ARCH).$(COMP).$(LINK).$(OPT)
 LIBNAME		=	$(NAME)-$(VERSION).$(BASE)
-LIBRARY		=	$(LIBDIR)/lib$(LIBNAME).a
-LIBRARYDBL	=	$(LIBDIR)/lib$(LIBNAME).dbl.a
+
+LIBRARY		=	$(LIBDIR)/lib$(LIBNAME)$(LIBEXT)
+LIBRARYDBL	=	$(LIBDIR)/lib$(LIBNAME).dbl$(LIBEXT)
+LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE)$(LIBEXT)
+LIBDBLLINK	=	$(LIBDIR)/lib$(NAME).$(BASE).dbl$(LIBEXT)
+
 BINARY		=	$(BINDIR)/$(BINNAME)
 BINARYDBL	=	$(BINDIR)/$(BINNAME).dbl
-LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE).a
-LIBDBLLINK	=	$(LIBDIR)/lib$(NAME).$(BASE).dbl.a
 BINLINK		=	$(BINDIR)/$(NAME).$(BASE)
 BINSHORTLINK	=	$(BINDIR)/$(NAME)
 DEPEND		=	$(SRCDIR)/depend
@@ -168,17 +175,23 @@
 
 $(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
 		@echo "-> linking $@"
-		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) -o $@
+ifeq ($(COMP), msvc)
+		$(LINKCC) $(CFLAGS) $(OBJXXX) $(LIBRARY) $(LDFLAGS) $(LINKCC_o)$@
+else
+		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) $(LINKCC_o)$@
+endif
 
 $(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL) 
 		@echo "-> linking $@"
-		$(CC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) -o $@
+		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) $(CC_o)$@
 
 $(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARY)
-		$(AR) $@ $(LIBXXX) $(ARFLAGS) 
+		$(AR) $(AR_o)$@ $(LIBXXX) $(ARFLAGS)
+ifneq ($(RANLIB),)
 		$(RANLIB) $@
+endif
 
 libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)
 
@@ -199,6 +212,9 @@
 lint:		$(OBJSRC) $(LIBSRC)
 		$(LINT) $(SRCDIR)/project.lnt \
 		$(CPPFLAGS) -UNDEBUG -Dinline= -DNO_MSHELL $^
+
+cppcheck:	$(OBJSRC) $(LIBSRC)
+		$(CPPCHECK) $(CPPFLAGS) --inline-suppr --enable=warning,style,performance,portability,information $^
 
 doc:
 		cd doc; make -f Makefile
@@ -248,6 +264,6 @@
 
 $(OBJDIR)/%.o:	$(SRCDIR)/%.c
 		@echo "-> compiling $@"
-		$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@
+		$(CC) $(CPPFLAGS) $(CFLAGS) -c $< $(CC_o)$@
 
 # --- EOF ---------------------------------------------------------------------

=== debian/changelog ===
zimpl (3.3.4-2) unstable; urgency=medium

  * Upload to unstable.
  * Update Standards-Version to 4.0.0 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Sun, 09 Jul 2017 19:06:11 +0200

zimpl (3.3.4-1) experimental; urgency=medium

  * New upstream release.
  * Fix BSD 3-clause license name in debian/copyright.
  * Add "export DEB_BUILD_MAINT_OPTIONS = hardening=+all" to debian/rules.
  * Update Standards-Version to 3.9.8 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Fri, 07 Apr 2017 21:37:37 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
 Build-Depends: debhelper (>= 9), libgmp-dev, zlib1g-dev, bison, flex
-Standards-Version: 3.9.5
+Standards-Version: 4.0.0
 Homepage: http://zimpl.zib.de/
 
 Package: zimpl

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 # export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@
